=== package/debian/control ===
Source: magnum-plugins
Priority: optional
Maintainer: Vladimír Vondruš <mosra@centrum.cz>
Build-Depends: debhelper (>= 9), cmake (>= 3.4), magnum-dev, libdevil-dev, libjpeg-dev, libpng-dev|libpng16-dev, libfaad-dev, libfreetype6-dev, libassimp-dev
Standards-Version: 3.9.2
Section: libs
Homepage: https://magnum.graphics
Vcs-Git: git://github.com/mosra/magnum-plugins.git
Vcs-Browser: https://github.com/mosra/magnum-plugins

Package: magnum-plugins-dev
Section: libdevel
Architecture: any
Depends: magnum-plugins (= ${binary:Version}), magnum-dev
Description: Plugins for the Magnum C++11/C++14 graphics engine

Package: magnum-plugins
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, magnum, libdevil1c2, libjpeg8|libjpeg62-turbo, libpng16-16, libfaad2, libfreetype6, libassimp3v5|libassimp4|libassimp5
Description: Plugins for the Magnum C++11/C++14 graphics engine
